#include <iostream>
#include <vector>
#include <queue>
#define MAX_N 400005
using namespace std;

vector<vector<int>> parents;
int red[MAX_N];
int newred[MAX_N];

void correct(int start)
{
    queue <int> opashka;
    int k;
    opashka.push(start);

    while(!opashka.empty())
    {
        k=opashka.front();
        opashka.pop();
        for(int i=0; i<parents[k].size(); i++)
        {
            newred[parents[k][i]]--;
            opashka.push(parents[k][i]);
        }
    }
}

int main()
{
    int n;
    cin >> n;
    parents.resize(n+1);

    for(int i=1; i<=n; i++)
    {
        cin >> red[i];
        if(red[i]!=0)
        {
            parents[red[i]].push_back(i);
        }
    }
    fill_n(newred, n+1, 1e8);

    for(int i=1; i<=n; i++)
    {
        correct(i);
        /*for(int i=1; i<=n; i++)
        {
            cout << newred[i] << " ";
        }*/
    }

    int currmin=1e8;

    for(int i=1; i<=n; i++)
    {
        currmin=min(currmin, newred[i]);
    }
    long long sum=0;
    for(int i=1; i<=n; i++)
    {
        newred[i]=newred[i]+1-currmin;
        sum+=newred[i];
    }
    cout << sum << endl;
    for(int i=1; i<=n; i++)
    {
        cout << newred[i] << " ";
    }


    return 0;
}
