#include <bits/stdc++.h>
using namespace std;

const int maxn = 4e5;
int n, a[maxn], par[maxn], ans[maxn];
bool start[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i;
    for (i=1; i<=n; ++i)
        cin >> a[i] ;

    for (i=n; i>0; --i)
    {
        if (a[i] == 0)
        {
            par[i] = i;
            start[i] = true;
        }
        else
        {
            par[i] = a[i];
            start[i] = true;
            start[a[i]] = false;
        }
    }
}

void dfs(int ver)
{
    ans[ver] = 1;
    int nb;
    while (par[ver] != ver)
    {
        nb = par[ver];
        ans[nb] = max(ans[nb], ans[ver] + 1);
        ver = nb;
    }
}

void solve()
{
    int i;
    for (i=1; i<=n; ++i)
    {
        if (start[i])
            dfs(i);
    }

    long long answer = 0;
    for (i=1; i<=n; ++i)
        answer += ((long long)(ans[i]));

    cout << answer << '\n' ;
    for (i=1; i<=n; ++i)
        cout << ans[i] << " " ;
    cout << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}