#include<bits/stdc++.h>
using namespace std;
const int maxn = 1000001;
int n,q;
int a[maxn];
int pos[maxn];
int used[maxn];
int lazy[maxn*4];

int b,e;

void push_lazy( int i, int l, int r )
{
    if( l == r )
    {
        used[l] = max(lazy[i],used[l]);
        //cout << l << " " << r << " " << lazy[i] << endl;
    }
    else
    {
        lazy[i*2] = max(lazy[i],lazy[i*2]);
        lazy[i*2+1] = max(lazy[i],lazy[i*2+1]);
    }
}
void update( int i, int l, int r, int ql, int qr)
{
    push_lazy(i,l,r);
    if( ql == l && qr == r )
    {
        //cout << l << " " << r << endl;
        lazy[i] = 1;
        push_lazy(i,l,r);
        return;
    }

    int m = ( l + r ) / 2;
    if( qr <= m ) update(i*2,l,m,ql,qr);
    else if( ql > m ) update(i*2+1,m+1,r,ql,qr);
    else
    {
        update(i*2,l,m,ql,m);
        update(i*2+1,m+1,r,m+1,qr);
    }
}

int query( int i, int l, int r, int p )
{
    push_lazy(i,l,r);
    if( l == r )
    {
        //cout << used[l] << " -- " << lazy[i] << endl;
        used[l] = max(lazy[i],used[l]);
        return used[l];
    }

    int m = ( l + r ) / 2;
    if( p <= m ) return query(i*2,l,m,p);
    else return query(i*2+1,m+1,r,p);
}
void read()
{
    cin >> n >> q;
    for( int i = 1; i <= n; i ++ )
    {
        cin >> a[i];
        pos[a[i]] = i;

        //cout << a[i] << " " << pos[a[i]] << endl;
    }

    b = 1;
    e = n;

    for( int i = 1; i <= q; i ++ )
    {
        int t;
        cin >> t;

        if( t == 1 )
        {
            int lamp;
            cin >>lamp;

            if( lamp == 1 )
            {
                cout << query(1,1,n,b);
                b += 1;
            }
            else
            {
                cout << query(1,1,n,e);
                e -= 1;
            }
        }
        else if( t == 2 )
        {
            int x,y;
            cin >> x >> y;
            //cout << pos[x] << " " << pos[y] << endl;
            update(1,1,n,pos[x],pos[y]);
        }
    }
    cout << endl;
}
int main()
{
    read();
    return 0;
}
