#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

int const MAXN=100001;
int n, q, a[MAXN], pos[MAXN], lazy[4*MAXN];

void push_lazy(int idx, int l, int r)
{
    if(lazy[idx] != 0)
    {
        //cout<<l<<" "<<r<<" "<<lazy[idx]<<endl;
        if(l != r)
        {
            lazy[idx*2] += lazy[idx];
            lazy[idx*2+1] += lazy[idx];
            lazy[idx] = 0;
        }
    }
}

void update(int idx, int l, int r, int ql, int qr)
{
    if(l > r || ql > r || qr < l) return;
    push_lazy(idx, l, r);
    //cout<<333<<endl;

    if(ql <= l && qr >= r)
    {
        lazy[idx]++;
        push_lazy(idx, l, r);
        //cout<<333<<endl;
        return;
    }
    int mid = (l+r)/2;
    update(idx*2, l, mid, ql, qr);
    update(idx*2+1, mid+1, r, ql, qr);
}

void print(int idx, int l, int r)
{
    cout<<l<<" "<<r<<" "<<lazy[idx]<<endl;
    if(l == r)
    {
        return;
    }
    int mid = (l+r)/2;
    print(idx*2, l, mid);
    print(idx*2+1, mid+1, r);
}

int query(int idx, int l, int r, int x)
{
    push_lazy(idx, l, r);
    if(l == r)
    {
        //cout<<lazy[idx]<<" "<<l<<endl;
        if(lazy[idx] > 0) return true;
        else return false;
    }
    int mid = (l+r)/2;
    if(x <= mid) return query(idx*2, l, mid, x);
    else return query(idx*2+1, mid+1, r, x);
}

void read()
{
    int l, r, x, start = 1, finish, type;
    cin>>n>>q;
    finish = n;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        pos[a[i]] = i;
    }
    for(int i=1;i<=q;i++)
    {
        //cout<<start<<" "<<n<<endl;
        cin>>type;
        if(type == 1)
        {
            //cout<<333<<endl;
            //print(1,1,n);

            cin>>x;
            if(x == 1)
            {
                cout<<query(1,1,n,start);
                start++;
            }
            else
            {
                cout<<query(1,1,n,finish);
                finish--;
            }
        }
        else if(type == 2)
        {
            cin>>l>>r;
            if(pos[l] <= pos[r]) update(1,1,n,pos[l],pos[r]);
            //cout<<endl;
            //print(1,1,n);
            //cout<<endl;
        }
        else
        {
            cin>>l>>r>>x;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
