#include<iostream>
#include<vector>
#define endl '\n'
using namespace std;
long long b[400005],rez[400005];
long long tree[1600005];
void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]=1;
        rez[l]=1;
        return;
    }
    int mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);
}
long long query(int node,int l,int r,int le,int ri)
{
    if(l>=le && r<=ri)
    {
        return tree[node];
    }
    if(r<le || l>ri)
        return 0;

    int mid=(l+r)/2;
    return max(query(2*node,l,mid,le,ri),query(2*node+1,mid+1,r,le,ri));
}
void update(int node,int l,int r,int p,long long val)
{
    if(l==r)
    {
        tree[node]=max(tree[node],val);
        rez[l]=tree[node];
        return;
    }
    if(l>p || r<p)
        return;

    int mid=(l+r)/2;

    update(2*node,l,mid,p,val);
    update(2*node+1,mid+1,r,p,val);
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,suma=0,t;
    cin>>n;

    build(1,1,n);
    for(long long i=1;i<=n;i++)
    {
        cin>>b[i];

        t=1;
        if(b[i]-i>1){
        t=query(1,1,n,i+1,b[i]-1);
        update(1,1,n,i,t);
        }

        update(1,1,n,b[i],rez[i]+1);
    }
     for(long long i=1;i<=n;i++)
        suma+=rez[i];

    cout<<suma<<endl;
    for(long long i=1;i<=n;i++)
        cout<<rez[i]<<" ";

    cout<<endl;
}

