#include<iostream>
#include<vector>
#pragma GCC optimize ("O3")
#include<cstring>
#define endl '\n'
using namespace std;
long long b[400005],rez[400005],n,suma=0,t;
long long tree[1600005];
long long query(int node,int l,int r,int le,int ri)
{
    if(l>=le && r<=ri)
    {
        return tree[node];
    }
    if(r<le || l>ri)
        return 0;

    int mid=(l+r)/2;
    return max(query(2*node,l,mid,le,ri),query(2*node+1,mid+1,r,le,ri));
}
void update(int node,int l,int r,int p,long long val)
{
    if(l>p || r<p)
        return;
    if(l==r)
    {
        tree[node]=max(tree[node],val);
        suma-=rez[l];
        rez[l]=tree[node];
        suma+=rez[l];
        return;
    }

    int mid=(l+r)/2;

    update(2*node,l,mid,p,val);
    update(2*node+1,mid+1,r,p,val);

    tree[node]=max(tree[2*node],tree[2*node+1]);
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;

    for(int i=1;i<=4*n;i++)
    {
        tree[i]=1;
    }
    for(int i=1;i<=n;i++)
        rez[i]=1;

    suma=n;

    for(int j=1;j<=2;j++)
    for(long long i=1;i<=n;i++)
    {
        if(j==1) cin>>b[i];
        if(b[i]==0)
        {
            t=query(1,1,n,i+1,n);
            update(1,1,n,i,t);
        }

        t=1;
        if(b[i]-i>1){
        t=query(1,1,n,i+1,b[i]-1);
        update(1,1,n,i,t);
        }

        update(1,1,n,b[i],rez[i]+1);
    }


    cout<<suma<<endl;

      for(long long i=1;i<=n;i++)
        cout<<rez[i]<<" ";cout<<endl;

}
