#include <bits/stdc++.h>
using namespace std;

const int maxn = 3*1024;
int n, q, a[maxn], idx[maxn], leftt, rightt, t[4*maxn], lazy[4*maxn];

void push_lazy(int i, int l, int r)
{
    if (lazy[i])
    {
        if (l != r)
            lazy[2*i] = lazy[2*i+1] = lazy[i];
        t[i] = lazy[i];
        lazy[i] = 0;
    }
}

int query(int i, int l, int r, int pos)
{
    push_lazy(i, l, r);
    if (l == r) return t[i];
    int mid = (l+r) >> 1;
    if (pos <= mid) return query(2*i, l, mid, pos);
    return query(2*i+1, mid+1, r, pos);
}

void update(int i, int l, int r, int ql, int qr)
{
    push_lazy(i, l, r);
    if (l > qr || r < ql) return;
    if (l >= ql && r <= qr)
    {
        lazy[i] = 1;
        push_lazy(i, l, r);
        return;
    }
    int mid = (l+r) >> 1;
    update(2*i, l, mid, ql, qr);
    update(2*i+1, mid+1, r, ql, qr);
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> q ;
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i] ;
        idx[a[i]] = i;
    }
    leftt = 1, rightt = n;

    int type, p, x, y;
    for (i=1; i<=q; ++i)
    {
        cin >> type ;
        if (type == 1)
        {
            cin >> p ;
            if (p == 1)
            {
                cout << query(1, 1, n, leftt);
                ++ leftt;
            }
            else
            {
                cout << query(1, 1, n, rightt);
                -- rightt;
            }
        }
        else
        {
            cin >> x >> y ;
            update(1, 1, n, idx[x], idx[y]);
        }
    }
}

int main()
{
    read();
    return 0;
}