#include<bits/stdc++.h>
using namespace std;
const int maxn = 1000001;
int n,q;
int a[maxn];
int cnt[maxn];
int p[maxn];

int tree[maxn*4];
int lazy[maxn*4];

int l;
int r;

void push_lazy( int i, int l, int r )
{
    tree[i] = max( tree[i] , lazy[i] );
    if( l != r )
    {
        lazy[i*2] = lazy[i];
        lazy[i*2+1] = lazy[i];
    }
    lazy[i] = 0;
}

void update( int i, int l, int r, int ql, int qr )
{
    push_lazy(i,l,r);
    if( l == ql && r == qr )
    {
        lazy[i] = 1;
        push_lazy(i,l,r);
        return;
    }

    int m = ( l + r ) / 2;
    if( qr <= m ) update(i*2,l,m,ql,qr);
    else if( ql > m ) update(i*2+1,m+1,r,ql,qr);
    else
    {
        update(i*2,l,m,ql,m);
        update(i*2+1,m+1,r,m+1,qr);
    }

    push_lazy(i*2,l,m);
    push_lazy(i*2+1,m+1,r);

    tree[i] = max( tree[i*2] , tree[i*2+1] );
}

int query( int i, int l, int r, int pos )
{
    push_lazy(i,l,r);
    if( l == r )
    {
        return tree[i];
    }

    int m = ( l + r ) / 2;
    if( pos <= m ) query(i*2,l,m,pos);
    else query(i*2+1,m+1,r,pos);
}
void read()
{
    cin >> n >> q;
    for( int i = 1; i <= n; i ++ )
    {
        cin >> a[i];
        p[a[i]] = i;
    }

    l = 1;
    r = n;

    for( int i = 1; i <= q; i ++ )
    {
        int t;
        cin >> t;

        if( t == 1 )
        {
            int lamp;
            cin >> lamp;
            if( lamp == 1 )
            {
                cout << query(1,1,n,p[a[l]]);
                //cout << a[l] << endl;
                //cout << p[a[l]] << endl;
                l += 1;
            }
            else
            {
                cout << query(1,1,n,p[a[r]]);
                r -= 1;
            }
        }
        else if( t == 2 )
        {
            int x,y;
            cin >> x >> y;
            int ql = p[x];
            int qr = p[y];

            cout << ql << " " << qr << endl;

            update(1,1,n,ql,qr);
            //cout << query(1,1,n,qr) << endl;
        }
    }
}
int main()
{
    read();
    //solve();
    return 0;
}
