#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

int const MAXN=300001;
int n, q, a[MAXN], b[MAXN], pos[MAXN], lazy[4*MAXN], tme[MAXN];

struct edge
{
    int type, l, r, x;
};

edge p[MAXN];

void push_lazy(int idx, int l, int r)
{
    if(lazy[idx] != 0)
    {
        //cout<<l<<" "<<r<<" "<<lazy[idx]<<endl;
        if(l != r)
        {
            lazy[idx*2] = max(lazy[idx], lazy[idx*2]);
            lazy[idx*2+1] = max(lazy[idx], lazy[idx*2+1]);
            lazy[idx] = 0;
        }
    }
}

void update(int idx, int l, int r, int ql, int qr, int t)
{
    if(l > r || ql > r || qr < l) return;
    push_lazy(idx, l, r);
    //cout<<333<<endl;

    if(ql <= l && qr >= r)
    {
        lazy[idx]=t;
        push_lazy(idx, l, r);
        //cout<<333<<endl;
        return;
    }
    int mid = (l+r)/2;
    update(idx*2, l, mid, ql, qr, t);
    update(idx*2+1, mid+1, r, ql, qr, t);
}

void print(int idx, int l, int r)
{
    cout<<l<<" "<<r<<" "<<lazy[idx]<<endl;
    if(l == r)
    {
        return;
    }
    int mid = (l+r)/2;
    print(idx*2, l, mid);
    print(idx*2+1, mid+1, r);
}

int query(int idx, int l, int r, int x)
{
    push_lazy(idx, l, r);
    if(l == r)
    {
        //cout<<lazy[idx]<<" "<<l<<endl;
        if(lazy[idx] > 0 /*&& lazy[idx] >= tme[x]*/) return true;
        else return false;
    }
    int mid = (l+r)/2;
    if(x <= mid) return query(idx*2, l, mid, x);
    else return query(idx*2+1, mid+1, r, x);
}

void read()
{
    int start = 1, finish;
    cin>>n>>q;
    finish = n;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    for(int i=1;i<=q;i++)
    {
        cin>>p[i].type;
        if(p[i].type == 1)
        {
            cin>>p[i].x;
        }
        else if(p[i].type == 2)
        {
            cin>>p[i].l>>p[i].r;
        }
        else
        {
            cin>>p[i].l>>p[i].r>>p[i].x;
            b[p[i].r]++;
        }
    }
    int cnt = 0;
    for(int i=1;i<=n;i++)
    {
        cnt += b[a[i]];
        pos[a[i]] = i+cnt;
        tme[pos[a[i]]] = 1;
    }
    for(int i=1;i<=3*n;i++)
    {
        a[pos[i]] = i;
    }
    n = 300010;
    for(int i=1;i<=q;i++)
    {
        if(p[i].type == 1)
        {
            if(p[i].x == 1)
            {
                cout<<query(1,1,n,start);
                start++;
            }
            else
            {
                cout<<query(1,1,n,finish);
                finish--;
            }
        }
        else if(p[i].type == 2)
        {
            if(pos[p[i].l] <= pos[p[i].r]) update(1,1,n,pos[p[i].l],pos[p[i].r],i);
        }
        else
        {
            pos[p[i].x] = pos[p[i].l]+1;
            a[pos[p[i].x]] = p[i].x;
            tme[pos[p[i].x]] = i;
            finish++;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
