#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long MAXN = 5e5 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

long long n;
long long a[MAXN];
vector < long long > leaders;
vector < long long > v[MAXN];
void read()
{
    cin >> n;
    for (long long i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        v[a[i]].push_back(i);
        if(a[i] == 0)
        {
            leaders.push_back(i);
        }
    }
}
long long height[MAXN];
long long dfs(long long beg)
{
    long long nb;
    long long maxh = 1;
    for (long long i = 0; i < v[beg].size(); ++ i)
    {
        nb = v[beg][i];
        maxh = max(maxh, dfs(nb)+1);
    }
    height[beg] = maxh;
    return maxh;
}

int t[MAXN * 4];

void make_tree(int i, int l, int r)
{
    if(l == r)
    {
        t[i] = height[l];
        return;
    }
    int mid = (l + r)/2;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    t[i] = max(t[2*i], t[2*i+1]);
}
int ql, qr;
int query(int i, int l, int r)
{
    if(ql > r || qr < l)return 0;
    if(ql <= l && r <= qr)return t[i];
    int mid = (l + r)/2;
    return max(query(2*i, l, mid), query(2*i+1, mid+1, r));
}
int val, x;
void update(int i, int l, int r)
{
    if(l == r)
    {
        t[i] = val;
        height[l] = val;
        return;
    }
    int mid = (l + r)/2;
    if(x <= mid)update(2*i, l, mid);
    else update(2*i+1, mid+1, r);
    t[i] = max(t[2*i], t[2*i+1]);
}
int main()
{
    speed();

    read();
    for (long long i = 0; i < leaders.size(); ++ i)
        dfs(leaders[i]);
    long long minn = 1;
    for (long long i = leaders.size()-1; i >= 0; -- i)
    {
        minn = max(minn, height[leaders[i]]);
        height[leaders[i]] = minn;
    }
    make_tree(1, 1, n);

    vector < pair </**dist, idx*/ int, int > > g;
    for (int i = 1; i <= n; ++ i)
    {
        if(a[i] == 0)continue;
        g.push_back(make_pair(a[i]-i, i));
    }
    sort(g.begin(), g.end());
    for (int i = 0; i < g.size(); ++ i)
    {
        int index = g[i].second;
        int indexto = index + g[i].first - 1;
        if(index + 1 >= indexto)continue;
        ql = index+1;
        qr = indexto;
        int minn = query(1, 1, n);
        if(minn > height[index])
        {
            val = minn;
            x = index;
            update(1, 1, n);
        }
    }
    /*minn = 1;
    for (long long i = leaders.size()-1; i >= 0; -- i)
    {
        minn = max(minn, height[leaders[i]]);
        height[leaders[i]] = minn;
    }*/
    long long sum = 0;
    for (long long i = 1; i <= n; ++ i)
    {
        sum += height[i];
    }
    cout << sum << endl;
    for (long long i = 1; i <= n; ++ i)
        cout << height[i] << " ";
    cout << endl;
    return 0;
}
/***
6
2 0 6 5 6 0
*/
